package edu.cmu.paid.authentication.test;

import java.io.*;
import java.lang.*;
import java.util.Random;
import edu.cmu.paid.authentication.crypto.*;
import edu.cmu.paid.authentication.util.*;
import java.math.BigInteger;

public class TestRsa {
    public static void main(String [] args) {
	int TESTSIZE=1000;

	byte [] b=ByteConverterWrapper.toByteArray(631);
	byte [] bb = ByteConverterWrapper.toByteArray(409);

	/*
	byte [] b=ByteConverterWrapper.toByteArray(1398269);
	byte [] bb = ByteConverterWrapper.toByteArray(420921);
	*/
	String s1="123456789012345678901234567890";
	String s2;
	Rsa crypt= TestWrapper.constructRsa(b, bb);
	int i;
	BigInteger [] keys=crypt.genKeys();

	System.out.println("Got the keys");

	byte [] cipher=crypt.encrypt(ByteConverterWrapper.toByteArray(s1), ByteConverterWrapper.toByteArray(keys[0].toString()));
	/*
	System.out.println("The encrypted message is: <"+(new String(cipher))+">.");
	*/
	byte [] clear=crypt.decrypt(cipher, ByteConverterWrapper.toByteArray(keys[1].toString()));
	s2=new String(clear);
	System.out.println("The original message is: <"+s1+">.");
	System.out.println("The decrypted message is: <"+s2+">.");

	if (!s1.equals(s2)) {
	    System.out.println("Encryption wrong, length 1 is : " + s1.length() + "length 2 is : " + s2.length() + ".");
	}


	Random r=new Random();
	int size, j;
	int count=0;

	while (count < TESTSIZE) {
	    System.out.print(count+"\t");
	    size=r.nextInt();
	    size=size % TESTSIZE;
	    size=size>0? size: -size;
	    b=new byte[size];
	    r.nextBytes(b);

	    cipher=crypt.encrypt(b, ByteConverterWrapper.toByteArray(11));
	    clear=crypt.decrypt(cipher, ByteConverterWrapper.toByteArray(163571));

	    /*
	    for (i=0;i<size-1;i++) {
		if (b[i]!=clear[i]) {
		    if ((new String(b)).charAt(i) == 0) {
			System.out.print("-");
			break;
		    }
		    System.out.println("Encryption wrong: " + i + ":" + size + " @ " + count + ".");
		    for (j=0;j<size;j++) {
			System.out.println("First Element: <" + (int) (new String(b)).charAt(j) + ">.");
		    }
		}
	    }
	    */
	    count++;
	}
    }
}
